use std::io::{Read, Write};
use std::net::{TcpListener, TcpStream};

mod parse;

fn parse_client(stream_buffer: &mut [u8]) -> parse::Result<()> {
    let start = parse::http_start(stream_buffer)?;
    loop {
        match parse::http_header(stream_buffer, start.total_length) {
            Ok(header) => {
                todo!();
            }
            Err(err) => match err {
                parse::Error::InvalidHeader => {
                    break;
                }
                err => return Err(err),
            },
        }
    }
    Ok(())
}

fn handle_client(mut stream: TcpStream) -> parse::Result<()> {
    let mut stream_buffer = Vec::from([0u8; 4096]);
    let bytes_read = stream.read(&mut stream_buffer)?;
    stream_buffer.truncate(bytes_read);
    parse_client(&mut stream_buffer)
}

fn main() -> std::io::Result<()> {
    let listener = TcpListener::bind("127.0.0.1:8080")?;
    for stream in listener.incoming() {
        if let Err(err) = handle_client(stream?) {
            println!("error occurred: {err:#?}");
        };
    }
    Ok(())
}
