#[derive(Debug, PartialEq, Eq)]
pub enum Error {
    InvalidHeader,
    InvalidString,
    Io,
}

impl From<std::string::FromUtf8Error> for Error {
    fn from(_: std::string::FromUtf8Error) -> Self {
        Error::InvalidString
    }
}

impl From<std::io::Error> for Error {
    fn from(_: std::io::Error) -> Self {
        Error::Io
    }
}

pub type Result<T> = std::result::Result<T, Error>;
